# gcp_storage_file – Return GC Storage content

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This lookup returns the contents from a file residing on Google Cloud Storage

## Requirements

The below requirements are needed on the local master node that executes this lookup.

- python >= 2.6
- requests >= 2.18.4
- google-auth >= 1.3.0

## Parameters

Parameter | Choices/Defaults | Configuration | Comments
--- | --- | --- | ---

auth_kind
string / required

Choices:
- application
- machineaccount
- serviceaccount

The type of credential used.

bucket - |  |  | The name of the bucket.
env_type string |  |  | Specifies which Ansible environment you're running this module within. This should not be set unless you know what you're doing. This only alters the User Agent string for any API requests.
project string |  |  | The Google Cloud Platform project to use.
scopes list |  |  | Array of scopes to be used.
service_account_contents jsonarg |  |  | The contents of a Service Account JSON file, either in a dictionary or as a JSON string that represents it.
service_account_email string |  |  | An optional service account email address if machineaccount is selected and the user does not wish to use the default email.
service_account_file path |  |  | The path of a Service Account JSON file if serviceaccount is selected as type.
src - |  |  | Source location of file (may be local machine or cloud depending on action).

## Notes

Note

- for authentication, you can set service_account_file using the c(gcp_service_account_file) env variable.
- for authentication, you can set service_account_contents using the c(GCP_SERVICE_ACCOUNT_CONTENTS) env variable.
- For authentication, you can set service_account_email using the `GCP_SERVICE_ACCOUNT_EMAIL` env variable.
- For authentication, you can set auth_kind using the `GCP_AUTH_KIND` env variable.
- For authentication, you can set scopes using the `GCP_SCOPES` env variable.
- Environment variables values will only be used if the playbook values are not set.
- The service_account_email and service_account_file options are mutually exclusive.

## Examples

    - debug: msg="the value of foo.txt is {{ lookup('gcp_storage_file',
        bucket='gcp-bucket', src='mydir/foo.txt', project='project-name',
        auth_kind='serviceaccount', service_account_file='/tmp/myserviceaccountfile.json') }}"

## Return Values

Common return values are documented here, the following are the fields unique to this lookup:

Key | Returned | Description
--- | --- | ---
_raw - |  | base64 encoded file content

## Status

- This lookup is not guaranteed to have a backwards compatible interface. [preview]
- This lookup is maintained by the Ansible Community. [community]

### Authors

- Eric Anderson <eanderson@avinetworks.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.

Hint

Configuration entries for each entry type have a low to high priority order. For example, a variable that is lower in the list will override a variable that is higher up.